﻿Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports AddinExpress.MSO
Imports PowerPoint = Microsoft.Office.Interop.PowerPoint
Imports Office = Microsoft.Office.Core

'Add-in Express Add-in Module
<GuidAttribute("D018E0B3-4956-470D-8DAF-91A69B443F9C"), ProgIdAttribute("PPTBaseObjects.AddinModule")> _
Public Class AddinModule
    Inherits AddinExpress.MSO.ADXAddinModule
    Friend WithEvents AdxRibbonTab1 As AddinExpress.MSO.ADXRibbonTab
    Friend WithEvents AdxRibbonGroup1 As AddinExpress.MSO.ADXRibbonGroup
    Friend WithEvents btnEnumeratePPTs As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents btnNewPPT As AddinExpress.MSO.ADXRibbonButton
    Friend WithEvents adxPowerPointEvents As AddinExpress.MSO.ADXPowerPointAppEvents

#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.AdxRibbonTab1 = New AddinExpress.MSO.ADXRibbonTab(Me.components)
        Me.AdxRibbonGroup1 = New AddinExpress.MSO.ADXRibbonGroup(Me.components)
        Me.btnEnumeratePPTs = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.btnNewPPT = New AddinExpress.MSO.ADXRibbonButton(Me.components)
        Me.adxPowerPointEvents = New AddinExpress.MSO.ADXPowerPointAppEvents(Me.components)
        '
        'AdxRibbonTab1
        '
        Me.AdxRibbonTab1.Caption = "PPT BASE OBJECTS"
        Me.AdxRibbonTab1.Controls.Add(Me.AdxRibbonGroup1)
        Me.AdxRibbonTab1.Id = "adxRibbonTab_ce720420a2554eccb3cb3c57b50f71db"
        Me.AdxRibbonTab1.Ribbons = AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation
        '
        'AdxRibbonGroup1
        '
        Me.AdxRibbonGroup1.Caption = "Tests"
        Me.AdxRibbonGroup1.Controls.Add(Me.btnEnumeratePPTs)
        Me.AdxRibbonGroup1.Controls.Add(Me.btnNewPPT)
        Me.AdxRibbonGroup1.Id = "adxRibbonGroup_46c39122c1c8458aa03bdb8628d507b0"
        Me.AdxRibbonGroup1.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.AdxRibbonGroup1.Ribbons = AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation
        '
        'btnEnumeratePPTs
        '
        Me.btnEnumeratePPTs.Caption = "EnumeratePPTs"
        Me.btnEnumeratePPTs.Id = "adxRibbonButton_053b6fa4485f4bf6a9cc389a3b3f2e70"
        Me.btnEnumeratePPTs.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnEnumeratePPTs.Ribbons = AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation
        '
        'btnNewPPT
        '
        Me.btnNewPPT.Caption = "Create New PPT"
        Me.btnNewPPT.Id = "adxRibbonButton_aa1cabc86c7e4e88a000124c8271b7fa"
        Me.btnNewPPT.ImageTransparentColor = System.Drawing.Color.Transparent
        Me.btnNewPPT.Ribbons = AddinExpress.MSO.ADXRibbons.msrPowerPointPresentation
        '
        'AddinModule
        '
        Me.AddinName = "PPTBaseObjects"
        Me.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaPowerPoint

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub AddinRegister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXRegister(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub AddinUnregister(ByVal t As Type)
        AddinExpress.MSO.ADXAddinModule.ADXUnregister(t)
    End Sub

    Public Overrides Sub UninstallControls()
        MyBase.UninstallControls()
    End Sub

#End Region

    Public Sub New()
        MyBase.New()

        Application.EnableVisualStyles()
        'This call is required by the Component Designer
        InitializeComponent()

        'Please add any initialization code to the AddinInitialize event handler

    End Sub

    Public Shared Shadows ReadOnly Property CurrentInstance() As AddinModule
        Get
            Return CType(AddinExpress.MSO.ADXAddinModule.CurrentInstance, AddinModule)
        End Get
    End Property

    Public ReadOnly Property PowerPointApp() As PowerPoint._Application
        Get
            Return CType(HostApplication, PowerPoint._Application)
        End Get
    End Property

#Region "Sample Code"

    Dim appPath As String

    Private Sub SetSomeApplicationSettings()

        appPath = PowerPointApp.Path

        If PowerPointApp.Visible Then
            PowerPointApp.DisplayAlerts = False
            PowerPointApp.DisplayGridLines = True
            PowerPointApp.Height = 600
            PowerPointApp.Width = 800
            PowerPointApp.Left = 200
            PowerPointApp.Top = 250
            PowerPointApp.ShowStartupDialog = Office.MsoTriState.msoFalse
        End If
    End Sub

    Private Sub EnumeratePresentations()
        Dim ppts As PowerPoint.Presentations = PowerPointApp.Presentations

        Dim path As String = Environment.GetFolderPath( _
            Environment.SpecialFolder.CommonDesktopDirectory)

        For i As Integer = ppts.Count To 1 Step -1
            Dim p As PowerPoint.Presentation = ppts(i)
            p.SaveAs(path & "\" & i.ToString() & ".pptx")
            p.Close()
            Marshal.ReleaseComObject(p)
        Next

        Marshal.ReleaseComObject(ppts)
    End Sub

    Private Function CreateNewPresentation(savePath As String) As  _
        PowerPoint.Presentation

        Dim newPPT As PowerPoint.Presentation = Nothing
        Dim ppts As PowerPoint.Presentations = PowerPointApp.Presentations

        newPPT = ppts.Add()
        Marshal.FinalReleaseComObject(ppts)
        Return newPPT
    End Function

    Private Function OpenNewPPT(filePath As String) As  _
        PowerPoint.Presentation

        Dim newPPT As PowerPoint.Presentation = Nothing
        Dim ppts As PowerPoint.Presentations = PowerPointApp.Presentations

        newPPT = ppts.Open(filePath)
        Marshal.FinalReleaseComObject(ppts)
        Return newPPT
    End Function

    Private Sub EnumerateSlides(ppt As PowerPoint.Presentation, themeName As String)
        Dim i As Integer
        Dim slides As PowerPoint.Slides = ppt.Slides

        For i = 1 To slides.Count
            Dim slide As PowerPoint.Slide = TryCast(slides(i), PowerPoint.Slide)
            If slide IsNot Nothing Then
                slide.ApplyTheme(themeName)
                Marshal.ReleaseComObject(slide)
            End If
        Next

        Marshal.ReleaseComObject(slides)
    End Sub

    Private Sub AddNewSlide(ppt As PowerPoint.Presentation)
        Dim layout As PowerPoint.CustomLayout
        Dim slide As PowerPoint.Slide
        Dim slides As PowerPoint.Slides
        Dim presentation As PowerPoint.Presentation

        presentation = PowerPointApp.ActivePresentation
        slide = presentation.Slides(1)
        layout = slide.CustomLayout
        Marshal.ReleaseComObject(presentation)
        Marshal.ReleaseComObject(slide)

        slides = ppt.Slides
        slide = slides.AddSlide(0, layout)

        Marshal.ReleaseComObject(slide)
        Marshal.ReleaseComObject(layout)
    End Sub

    Private Sub DeleteSlide(ppt As PowerPoint.Presentation, slideName As String)
        Dim i As Integer
        Dim slides As PowerPoint.Slides

        PowerPointApp.DisplayAlerts = False
        slides = ppt.Slides

        For i = 1 To slides.Count
            Dim slide As PowerPoint.Slide = TryCast(slides(i), PowerPoint.Slide)
            If slide.Name = slideName Then
                slide.Delete()
                Marshal.ReleaseComObject(slide)
                Exit For
            End If
            Marshal.ReleaseComObject(slide)
        Next

        PowerPointApp.DisplayAlerts = True
        Marshal.ReleaseComObject(slides)
    End Sub

    Private Sub EnumerateShapes(slide As PowerPoint.Slide)
        Dim i As Integer
        Dim shapes As PowerPoint.Shapes = slide.Shapes

        For i = 1 To shapes.Count
            Dim shape As PowerPoint.Shape = TryCast(shapes(i), PowerPoint.Shape)
            If shape IsNot Nothing Then
                shape.Left = shape.Left + 1
                Marshal.ReleaseComObject(shape)
            End If
        Next

        Marshal.ReleaseComObject(shapes)
    End Sub

    Private Sub AddShapeToSlide(slide As PowerPoint.Slide)
        Dim shape As PowerPoint.Shape
        Dim shapes As PowerPoint.Shapes = slide.Shapes

        shape = shapes.AddShape(Office.MsoAutoShapeType.msoShape7pointStar, _
            50, 50, 50, 50)
        'shape = shapes.AddCallout(Office.MsoCalloutType.msoCalloutThree, _
        '50, 50, 50, 50)

        Marshal.ReleaseComObject(shapes)
        Marshal.ReleaseComObject(shape)
    End Sub

    Private Sub DeleteShape(slide As PowerPoint.Slide, containsText As String)
        Dim i As Integer
        Dim shapes As PowerPoint.Shapes = slide.Shapes

        For i = shapes.Count To 1 Step -1
            Dim shape As PowerPoint.Shape = TryCast(shapes(i), PowerPoint.Shape)
            If shape.TextFrame.TextRange.Text = containsText Then
                shape.Delete()
            End If
            Marshal.ReleaseComObject(shape)
        Next
        Marshal.ReleaseComObject(shapes)
    End Sub

    Private Sub ChangeSelectionText(newText As String)
        Dim window As PowerPoint.DocumentWindow
        Dim selection As PowerPoint.Selection
        Dim range As PowerPoint.TextRange

        window = PowerPointApp.ActiveWindow
        selection = window.Selection
        range = selection.TextRange
        range.Text = newText

        Marshal.ReleaseComObject(range)
        Marshal.ReleaseComObject(selection)
        Marshal.ReleaseComObject(window)
    End Sub

#End Region

    Private Sub AddinModule_AddinInitialize(sender As Object, e As EventArgs) Handles Me.AddinInitialize
        SetSomeApplicationSettings()
    End Sub

    Private Sub btnEnumeratePPTs_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnEnumeratePPTs.OnClick
        EnumeratePresentations()
    End Sub

    Private Sub btnNewPPT_OnClick(sender As Object, control As IRibbonControl, pressed As Boolean) Handles btnNewPPT.OnClick
        CreateNewPresentation("C:\")
    End Sub
End Class

